; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     80x87 Round Routine                             *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2001-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   F87HRND

             INCLUDE SE.ASM

             .386
             .387

        if Emul87
             EMUL
        else
             NOEMUL
        endif

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  FRound

;-------------------------------------------------------------------------------
; FRound respresents the ROUND standard function for code compiled in the {$N+}
; state. If the result of the operation overflows the LONGINT format, an
; overflow exception is signaled.
;
; On entry:  ST(0)   number
;
; On exit:   DX:AX   round (number)
;            OE      set, if result overflows LONGINT format
;            ST=ST+1
;
; DESTROYS:  AX, BX, DX, Flags
;-------------------------------------------------------------------------------

; Round function

FRound       PROC    FAR

             push    eax
             mov     bx, sp

             fistp   dword ptr ss:[bx] ; store TOS register to LONGINT variable
             fwait                     ; required?

             pop     ax
             pop     dx
             ret

FRound       ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END