; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     80x87 Sin/Cos Functions                         *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   F87HSICO

             INCLUDE SE.ASM

             .386
             .387

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  FSin
             PUBLIC  FCos

; Externals

             EXTRN   HaltError: NEAR

; Sin function

FSin         PROC FAR

        if Emul87

             int     3eh
             dw      scSin

             ret
        else

             fsin
             jmp     $check            ; check for overflow and errors, return

        endif

FSin         ENDP

             INCLUDE ALIGN.ASM

; Cos function

FCos         PROC FAR

        if Emul87

             int     3eh
             dw      scCos

        else
             fcos

$check:      wait                      ; check for unmasked exceptions
             fnstsw  ax                ; get FPU condition codes
             sahf                      ; transfer condition codes to CPU flags
             mov     ax, 207           ; error code 207, illegal float operation
             jp      HaltError         ; argument out of in range

        endif

             ret

FCos         ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END