; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Longint Division                                *
; *                                                     *
; *     Copyright (C) 1989-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   LONGDIV

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Externals

             EXTRN   HaltError: NEAR

; Publics

             PUBLIC  LongDiv

;-------------------------------------------------------------------------------
; LongDiv divides two LONGINT numbers, the dividend and the divisor, resulting
; in a quotient and a remainder. The routine checks for an attempted division
; by zero. In that case, it returns to the error handler with error code C8h.
;
; INPUT:     DX:AX     dividend
;            BX:CX     divisor
;
; OUTPUT:    DX:AX     quotient of division of dividend by divisor
;            BX:CX     remainder of division of dividend by divisor
;
; DESTROYS:  EAX,EBX,ECX,EDX,Flags
;-------------------------------------------------------------------------------

LongDiv      PROC    FAR

             shl     eax, 16
             shrd    eax, edx, 16
             shl     ecx, 16
             shrd    ecx, ebx, 16
             jz      short $zero_divide

             cdq
             idiv    ecx
             mov     ecx, edx
             shld    edx, eax, 16
             shld    ebx, ecx, 16
             retf

$zero_divide:add     sp, 4             ; remove saved flags from stack
             mov     ax, 200           ; error code 200, "division by zero"
             jmp     HaltError         ; execute error handler

LongDiv      ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END