; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Longint Shift Left                              *
; *                                                     *
; *     Copyright (C) 1989-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   LONGSHL

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  LongShl

;-------------------------------------------------------------------------------
; LongShl performs a logical left shift on its LONGINT argument, that is, the
; sign is not preserved and there is no check if the results overflows the
; LONGINT format.
;
; INPUT:     DX:AX     argument
;            CX        count
;
; OUTPUT:    DX:AX     argument SHL count
;
; DESTROYS:  AX,EDX,Flags
;-------------------------------------------------------------------------------

LongShl      PROC    FAR

             shl     edx, 16           ; make room for LSW
             mov     dx, ax            ; add in LSW
             shl     edx, cl           ; perform shift
             mov     ax, dx            ; put LSW back
             shr     edx, 16           ; shift MSW back to dx
             ret

LongShl      ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END