; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Longint Shift Right                             *
; *                                                     *
; *     Copyright (C) 1989-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   LONGSHR

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  LongShr

;-------------------------------------------------------------------------------
; LongShr performs a logical right shift on its LONGINT argument, that is, the
; sign for negative numbers is not preserved. It allows a variable shift count
; to be used.
;
; INPUT:     DX:AX     argument
;            CX        count
;
; OUTPUT:    DX:AX     argument SHR count
;
; DESTROYS:  AX,EDX,Flags
;-------------------------------------------------------------------------------

LongShr      PROC    FAR

             shl     edx, 16           ; make room for LSW
             mov     dx, ax            ; add in LSW
             shr     edx, cl           ; perform shift
             mov     ax, dx            ; put LSW back
             shr     edx, 16           ; shift MSW back to dx
             ret

LongShr      ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END