; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Set Difference Routine                          *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   SETHDIF

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZDifference

;-------------------------------------------------------------------------------
; ZDifference implements the standard set operator '-'. It creates the differ-
; ence of the sets, each of with is contained in a 32-byte set buffer. The
; resulting set contains all elements of the second set that are not at the
; same time members of the first set. This can be implemented by applying the
; following formula bitwise on the sets: Result := SecondSet AND (NOT FirstSet).
; The resulting set overwrites one of the two original sets.
;
; On entry:  [SP+4]  Pointer to first set buffer (= source)
;            [SP+8]  Pointer to second set buffer (= destination)
;
; On exit:   [SP]    Pointer to output set buffer
;-------------------------------------------------------------------------------

ZDifference  PROC    FAR

             mov     bx, sp            ; make new frame pointer
             mov     dx, ds            ; save TURBO data segment
             les     di, ss:[bx + 8]   ; pointer to source set buffer
             lds     si, ss:[bx + 4]   ; pointer to destination set buffer
             mov     cx, 8             ; set buffers contain 8 dwords of data

@@1:         mov     eax, [si]         ; get dword from first set
             add     si, 4
             not     eax               ; invert it
             and     es:[di], eax      ; AND it with appropriate dword of dest.
             add     di, 4
             dec     cx
             jnz     @@1               ; until all 8 dwords in buffer thru

             mov     ds, dx            ; restore TURBO data segment
             ret     4                 ; leave destination pointer on stack

ZDifference  ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END