{*******************************************************}
{                                                       }
{       Turbo Pascal Runtime Library Version 7.0        }
{       System Unit                                     }
{                                                       }
{       Copyright (C) 1988-1992 Borland International   }
{       Copyright (C) 1991-1994 Norbert Juffa           }
{       Copyright (C) 2003-2003 Robert AH Prins         }
{                                                       }
{*******************************************************}

unit System;

{ This unit implements Turbo Pascal's runtime library. When }
{ compiling this unit, the compiler automatically includes  }
{ a boot-strap symbol table (SYSTEM.TPS) which declares all }
{ built-in types, procedures, and functions.                }

{}{$IFDEF DPMI}{}
{$C FIXED PRELOAD PERMANENT}
{}{$ENDIF}{}

{}{$IFDEF WINDOWS}{}
{$C MOVEABLE PRELOAD PERMANENT}
{}{$ENDIF}{}

{}{$IFDEF MSDOS}{}
{$L MAIN.OBJ}           { Main module }
{}{$ENDIF}{}

{$L VARH.OBJ}           { Variable support routines }

{ $L LONG.OBJ}          { Longint arithmetic routines }
{$L LONGMUL.OBJ}
{$L LONGDIV.OBJ}
{$L LONGSHR.OBJ}
{$L LONGSHL.OBJ}
{$L LOVF.OBJ}           { Longint arith with overflow checks }

{ $L FP48.OBJ}          { Real kernel routines }
{$L FP48KER.OBJ}
{$L FP48CMP.OBJ}
{$L FP48RND.OBJ}
{$L FP48FLT.OBJ}

{ $L F48H.OBJ}          { Real support routines }
{ $L F48F.OBJ}          { Real standard functions }
{$L F48FINT.OBJ}
{$L F48FFRC.OBJ}
{$L F48FSRT.OBJ}
{$L F48FSIN.OBJ}
{$L F48FLOG.OBJ}
{$L F48FEXP.OBJ}
{$L F48FATN.OBJ}
{$L F48FPOL.OBJ}
{$L F48FRED.OBJ}
{$L FASTMUL2.OBJ}

{ $L STRH.OBJ}          { String support routines }
{$L STRHLOD.OBJ}
{$L STRHSTO.OBJ}
{$L STRHCPY.OBJ}
{$L STRHCAT.OBJ}
{$L STRHPOS.OBJ}
{$L STRHCMP.OBJ}
{$L STRHCHR.OBJ}
{$L STRHPCK.OBJ}
{$L STRHINS.OBJ}
{$L STRHDEL.OBJ}

{ $L SETH.OBJ}          { Set support routines }
{$L SETHLOD.OBJ}
{$L SETHWLD.OBJ}
{$L SETHADC.OBJ}
{$L SETHSTO.OBJ}
{$L SETHADR.OBJ}
{$L SETHMSK.OBJ}
{$L SETHUNIT.OBJ}
{$L SETHDIF.OBJ}
{$L SETHITS.OBJ}
{$L SETHEQU.OBJ}
{$L SETHREL.OBJ}

{ $L DINT.OBJ}          { Integer Binary/Decimal routines }
{$L DINTI2S.OBJ}
{$L DINTS2I.OBJ}

{ $L SINT.OBJ}          { Integer Str/Val routines }
{$L SINTVAL.OBJ}
{$L SINTSTR.OBJ}

{ $L SF48.OBJ}          { Real Str/Val routines }
{$L SF48VAL.OBJ}
{$L SF48STR.OBJ}
{$L SFHELP.OBJ}

{ $L DF48.OBJ}          { Real Binary/Decimal routines }
{$L DF48HLP.OBJ}
{$L DF48R2S.OBJ}
{$L DF48S2R.OBJ}

{ $L RAND.OBJ}          { Random number generator }
{$L RANDKER.OBJ}
{$L RANDINI.OBJ}
{$L RANDINT.OBJ}
{$L RANDF48.OBJ}
{$L RANDF87.OBJ}

{$L CHAR.OBJ}           { Character handling routines }

{ $L MEMH.OBJ}          { Block move and fill routines }
{$L MEMHMOV.OBJ}
{$L MEMHFIL.OBJ}

{ $L SF87.OBJ}          { 80x87 Str/Val routines }
{$L SF87STR.OBJ}
{$L SF87VAL.OBJ}

{$L TFIO.OBJ}           { Textfile open routine }

{ $L FFUN.OBJ}          { File support functions }
{$L FFUNPOS.OBJ}
{$L FFUNSIZ.OBJ}
{$L FFUNEOF.OBJ}
{$L FFUNKER.OBJ}

{$L DMTH.OBJ}           { Dynamic method call dispatcher }

{$L TRDCALLB.OBJ}       { Read callback routine }

{}{$IFDEF MSDOS}{}

{ $L HEAP.OBJ}          { Heap manager }
{$L HEAPNME.OBJ}
{$L HEAPNPT.OBJ}
{$L HEAPDME.OBJ}
{$L HEAPDPT.OBJ}
{$L HEAPMRK.OBJ}
{$L HEAPREL.OBJ}
{$L HEAPSTA.OBJ}

{ $L ERRC.OBJ}          { Error check routines }
{$L ERRCIOG.OBJ}        { ERRIO }
{$L ERRCIOC.OBJ}        { ERRIO }
{$L ERRCRNG.OBJ}
{$L ERRCSTK.OBJ}
{$L ERRCOVR.OBJ}

{}{$IFNDEF EMU87}{}
{$L EI8X.OBJ}           { Hw/Sw Emulator initialization    }
{}{$ELSE}{}
{$L EI86.OBJ }          { Software emulator initialization }
{$L EI87.OBJ }          { Hardware emulator initialization }
{}{$ENDIF}{}

{ $L F87H.OBJ}          { 80x87 support routines }
{$L F87HKER.OBJ}
{$L F87HSQRT.OBJ}       { F87HTRN }
{$L F87HSICO.OBJ}       { F87HTRN }
{$L F87HATAN.OBJ}       { F87HTRN }
{$L F87HEXP.OBJ}        { F87HTRN }
{$L F87HLN.OBJ}         { F87HTRN }
{$L F87HR2E.OBJ}
{$L F87HE2R.OBJ}
{$L F87HTRC.OBJ}        { F87HKER }
{$L F87HRND.OBJ}        { F87HKER }
{$L F87HINT.OBJ}        { F87HKER }
{$L F87HFRC.OBJ}        { F87HKER }

{}{$IFDEF EMU87}{}
{$L EM87E.OBJ}          { Hardware 80x87 emulator }
{$L EM86.OBJ}           { Software 80x87 emulator }
{}{$ELSE}{}
{$L EM87.OBJ}           { Hardware 80x87 emulator }
{}{$ENDIF}{}
{}{$ENDIF}{}

{}{$IFNDEF WINDOWS}{}
{ $L OBJH.OBJ}          { Object handling routines }
{$L OBJHCON.OBJ}
{$L OBJHDES.OBJ}
{$L OBJHCPY.OBJ}
{$L OBJHCHK.OBJ}

{ $L DF87.OBJ}          { 80x87 Binary/Decimal routines }
{$L DF87HLP.OBJ}
{$L DF87F2S.OBJ}
{$L DF87S2F.OBJ}

{ $L TCTL.OBJ}          { Textfile control routines }
{$L TCTLKER.OBJ}
{$L TCTLHLP.OBJ}

{ $L TGPC.OBJ}          { Textfile low-level I/O }
{$L TGPCRD.OBJ}
{$L TGPCWR.OBJ}
{$L TGPCEND.OBJ}
{$L TGPCIO.OBJ}
{$L TGPCTXT.OBJ}
{$L TGPCPAD.OBJ}
{$L TGPCBUF.OBJ}
{$L TGPCFLS.OBJ}

{ $L TCHR.OBJ}          { Textfile character I/O }
{$L TCHRRD.OBJ}
{$L TCHRWR.OBJ}

{ $L TPCH.OBJ}          { Textfile character array I/O}
{$L TPCHRD.OBJ}
{$L TPCHWR.OBJ}

{ $L TSTR.OBJ}          { Textfile string I/O }
{$L TSTRRD.OBJ}
{$L TSTRWR.OBJ}

{$L TBOL.OBJ}           { Textfile boolean I/O }

{ $L TINT.OBJ}          { Textfile integer I/O }
{$L TINTRD.OBJ}
{$L TINTWR.OBJ}

{ $L TF48.OBJ}          { Textfile real I/O }
{$L TF48RD.OBJ}
{$L TF48WR.OBJ}

{ $L TF87.OBJ}          { Textfile 80x87 I/O }
{$L TF87RD.OBJ}
{$L TF87WR.OBJ}

{$L TFUN.OBJ}           { Textfile support functions }

{ $L FCTL.OBJ}          { File control routines }
{$L FCTLASS.OBJ}
{$L FCTLKER.OBJ}
{$L FCTLR_W.OBJ}
{$L FCTLBLK.OBJ}
{$L FCTLSEK.OBJ}
{$L FCTLTRC.OBJ}

{ $L FDIR.OBJ}          { File utility routines }
{$L FDIRREN.OBJ}
{$L FDIRDEL.OBJ}

{ $L CINT.OBJ}          { Integer Str/Val routines }
{$L CINTVAL.OBJ}

{ $L CF48.OBJ}          { Real Str/Val routines }
{$L CF48VAL.OBJ}

{ $L CF87.OBJ}          { 80x87 Str/Val routines }
{$L CF87VAL.OBJ}

{ $L PARS.OBJ}          { Command line parameter routines }
{$L PARSSTR.OBJ}
{$L PARSCNT.OBJ}
{$L PARSKER.OBJ}

{ $L DIRH.OBJ}          { Directory handling routines }
{$L DIRHGET.OBJ}
{$L DIRHHLP.OBJ}
{$L DIRHMAK.OBJ}
{$L DIRHREM.OBJ}
{$L DIRHSET.OBJ}

{}{$ELSE}{}

{$L WAPP.OBW}           { Windows application main module }
{$L WLIB.OBW}           { Windows library main module }
{$L WEND.OBW}           { Windows termination procedures }
{$L WMEM.OBW}           { Windows heap manager }

{ $L ERRC.OBW}          { Error check routines }
{$L ERRCIOG.OBJ}        { ERRIO }
{$L ERRCIOC.OBJ}        { ERRIO }
{$L ERRCRNG.OBJ}
{$L ERRCSTK.OBW}
{$L ERRCOVR.OBJ}

{ $L OBJH.OBW}          { Object handling routines }
{$L OBJHCON.OBW}
{$L OBJHDES.OBW}
{$L OBJHCPY.OBJ}
{$L OBJHCHK.OBJ}

{ $L DF87.OBW}          { 80x87 Binary/Decimal routines }
{$L DF87HLP.OBJ}
{$L DF87F2S.OBW}
{$L DF87S2F.OBJ}

{ $L TCTL.OBW}          { Textfile control routines }
{$L TCTLKER.OBW}
{$L TCTLHLP.OBJ}

{ $L TGPC.OBW}          { Textfile low-level I/O }
{$L TGPCRD.OBW}
{$L TGPCWR.OBW}
{$L TGPCEND.OBW}
{$L TGPCIO.OBJ}
{$L TGPCTXT.OBJ}
{$L TGPCPAD.OBJ}
{$L TGPCBUF.OBJ}
{$L TGPCFLS.OBJ}

{ $L TCHR.OBW}          { Textfile character I/O }
{$L TCHRRD.OBW}
{$L TCHRWR.OBW}

{ $L TSTR.OBW}          { Textfile string I/O }
{$L TSTRRD.OBW}
{$L TSTRWR.OBW}

{ $L TPCH.OBW}          { Textfile character array I/O}
{$L TPCHRD.OBW}
{$L TPCHWR.OBW}

{$L TBOL.OBW}           { Textfile boolean I/O }

{ $L TINT.OBW}          { Textfile integer I/O }
{$L TINTRD.OBW}
{$L TINTWR.OBW}

{ $L TF48.OBW}          { Textfile real I/O }
{$L TF48RD.OBW}
{$L TF48WR.OBW}

{ $L TF87.OBW}          { Textfile 80x87 I/O }
{$L TF87RD.OBW}
{$L TF87WR.OBW}

{$L TFUN.OBW}           { Textfile support functions }

{ $L FCTL.OBW}          { File control routines }
{$L FCTLASS.OBW}
{$L FCTLKER.OBJ}
{$L FCTLR_W.OBJ}
{$L FCTLBLK.OBJ}
{$L FCTLSEK.OBJ}
{$L FCTLTRC.OBJ}

{ $L FDIR.OBW}          { File utility routines }
{$L FDIRREN.OBW}
{$L FDIRDEL.OBJ}

{ $L CINT.OBW}          { Integer Str/Val routines }
{$L CINTVAL.OBJ}

{ $L CF48.OBW}          { Real Str/Val routines }
{$L CF48VAL.OBJ}

{ $L CF87.OBW}          { 80x87 Str/Val routines }
{$L CF87VAL.OBJ}

{ $L WPAR.OBW}          { Command line parameter routines }
{$L WPARSTR.OBW}
{$L WPARCNT.OBW}
{$L WPARKER.OBW}

{ $L DIRH.OBW}          { Directory handling routines }
{$L DIRHGET.OBW}
{$L DIRHHLP.OBW}
{$L DIRHMAK.OBJ}
{$L DIRHREM.OBJ}
{$L DIRHSET.OBJ}

{$L WI87.OBW}           { 80x87 initialization }
{$L WX87.OBW}           { 80x87 exception handler }
{$L WE87.OBW}           { 80x87 support routines }
{$L F87HSQRT.OBJ}       { WE87 }
{$L F87HR2E.OBJ}        { WE87 }
{$L F87HE2R.OBJ}        { WE87 }
{$L F87HTRC.OBJ}        { WE87 }
{$L F87HRND.OBJ}        { WE87 }
{$L F87HINT.OBJ}        { WE87 }
{$L F87HFRC.OBJ}        { WE87 }

{$L WF87.OBJ}           { 80x87 transcendental routines }

{}{$ENDIF}{}

{}{$IFDEF DPMI}{}

{$L DAPP.OBP}           { DPMI application main module }
{$L DLIB.OBP}           { DPMI library main module }
{$L DEND.OBP}           { DPMI termination procedures }
{$L WMEM.OBP}           { DPMI heap manager }

{ $L ERRC.OBP}          { Error check routines }
{$L ERRCIOG.OBJ}        { ERRIO }
{$L ERRCIOC.OBJ}        { ERRIO }
{$L ERRCRNG.OBJ}
{$L ERRCSTK.OBP}
{$L ERRCOVR.OBJ}

{}{$IFNDEF EMU87}{}
{$L EI8X.OBJ}           { Hw/Sw Emulator initialization    }
{}{$ELSE}{}
{$L EI86.OBP}           { Software emulator initialization }
{$L EI87.OBP}           { Hardware emulator initialization }
{}{$ENDIF}{}

{ $L F87H.OBP}          { 80x87 support routines }
{$L F87HKER.OBP}
{$L F87HSQRT.OBJ}       { F87HTRN }
{$L F87HSICO.OBJ}       { F87HTRN }
{$L F87HATAN.OBJ}       { F87HTRN }
{$L F87HEXP.OBJ}        { F87HTRN }
{$L F87HLN.OBJ}         { F87HTRN }
{$L F87HR2E.OBJ}
{$L F87HE2R.OBJ}
{$L F87HTRC.OBJ}        { F87HKER }
{$L F87HRND.OBJ}        { F87HKER }
{$L F87HINT.OBJ}        { F87HKER }
{$L F87HFRC.OBJ}        { F87HKER }

{}{$IFDEF EMU87}{}
{$L EM87E.OBP}          { Hardware 80x87 emulator }
{$L EM86.OBP}           { Software 80x87 emulator }
{}{$ELSE}{}
{$L EM87.OBP}           { Hardware 80x87 emulator }
{}{$ENDIF}{}
{}{$ENDIF}{}

{}{$IFDEF MSDOS}{}
{$L LAST.OBJ}           { Data segment initialization }
{}{$ENDIF}{}

interface

{ Initialized public variables. The compiler depends upon the  }
{ order of declaration of the following typed constants, so it }
{ must not be changed. In addition, the following declaration  }
{ section must be the first "const" section in this unit.      }

const
{}{$IFDEF MSDOS}{}
  OvrCodeList : Word    = 0;     { Overlay code segment list   }
  OvrHeapSize : Word    = 0;     { Initial overlay buffer size }
  OvrDebugPtr : Pointer = nil;   { Overlay debugger hook       }
  OvrHeapOrg  : Word    = 0;     { Overlay buffer origin       }
  OvrHeapPtr  : Word    = 0;     { Overlay buffer pointer      }
  OvrHeapEnd  : Word    = 0;     { Overlay buffer end          }
  OvrLoadList : Word    = 0;     { Loaded overlays list        }
  OvrDosHandle: Word    = 0;     { Overlay DOS handle          }
  OvrEmsHandle: Word    = $FFFF; { Overlay EMS handle          }
  HeapOrg     : Pointer = nil;   { Heap origin                 }
  HeapPtr     : Pointer = nil;   { Heap pointer                }
  HeapEnd     : Pointer = nil;   { Heap end                    }
  FreeList    : Pointer = nil;   { Free list pointer           }
  FreeZero    : Pointer = nil;   { Must be zero                }
  HeapError   : Pointer = nil;   { Heap error function         }
  ExitProc    : Pointer = nil;   { Exit procedure              }
  ExitCode    : Integer = 0;     { Exit code                   }
  ErrorAddr   : Pointer = nil;   { Runtime error address       }
  PrefixSeg   : Word    = 0;     { Program segment prefix      }
  StackLimit  : Word    = 512;   { Stack pointer low limit     }
  InOutRes    : Integer = 0;     { I/O result buffer           }
  RandSeed    : Longint = 0;     { Random seed                 }
  SelectorInc : Word    = $1000; { Selector increment          }
  Seg0040     : Word    = $0040; { Selector for segment $0040  }
  SegA000     : Word    = $A000; { Selector for segment $A000  }
  SegB000     : Word    = $B000; { Selector for segment $B000  }
  SegB800     : Word    = $B800; { Selector for segment $B800  }
  Test8086    : Byte    = 0;     { 80x86 test result           }
  Test8087    : Byte    = 0;     { 80x87 test result           }
  FileMode    : Byte    = 2;     { File open mode              }
{}{$ENDIF}{}

{}{$IFDEF DPMI}{}
  HInstance     : Word    = 0;    { Module instance handle               }
  HeapList      : Word    = 0;    { Heap segment list                    }
  HeapLimit     : Word    = 1024; { Heap small block limit               }
  HeapBlock     : Word    = 8192; { Heap block size                      }
  HeapAllocFlags: Word    = 2;    { Heap allocation flags, gmem_Moveable }
  HeapError     : Pointer = nil;  { Heap error function                  }
  ExitProc      : Pointer = nil;  { Exit procedure                       }
  ExitCode      : Integer = 0;    { Exit code                            }
  ErrorAddr     : Pointer = nil;  { Runtime error address                }
  PrefixSeg     : Word    = 0;    { Program segment prefix               }
  InOutRes      : Integer = 0;    { I/O result buffer                    }
  RandSeed      : Longint = 0;    { Random seed                          }
  SelectorInc   : Word    = 0;    { Selector increment                   }
  Seg0040       : Word    = 0;    { Selector for segment $0040           }
  SegA000       : Word    = 0;    { Selector for segment $A000           }
  SegB000       : Word    = 0;    { Selector for segment $B000           }
  SegB800       : Word    = 0;    { Selector for segment $B800           }
  Test8086      : Byte    = 0;    { 80x86 test result                    }
  Test8087      : Byte    = 0;    { 80x87 test result                    }
  FileMode      : Byte    = 2;    { File open mode                       }
{}{$ENDIF}{}

{}{$IFDEF WINDOWS}{}
  HPrevInst     : Word    = 0;    { Handle of previous instance          }
  HInstance     : Word    = 0;    { Handle of this instance              }
  CmdShow       : Integer = 0;    { CmdShow parameter for CreateWindow   }
  CmdLine       : PChar   = nil;  { Command line pointer                 }
  HeapList      : Word    = 0;    { Heap segment list                    }
  HeapLimit     : Word    = 1024; { Heap small block limit               }
  HeapBlock     : Word    = 8192; { Heap block size                      }
  HeapAllocFlags: Word    = 2;    { Heap allocation flags, gmem_Moveable }
  HeapError     : Pointer = nil;  { Heap error function                  }
  ExitProc      : Pointer = nil;  { Exit procedure                       }
  ExitCode      : Integer = 0;    { Exit code                            }
  ErrorAddr     : Pointer = nil;  { Runtime error address                }
  PrefixSeg     : Word    = 0;    { Program segment prefix               }
  InOutRes      : Integer = 0;    { I/O result buffer                    }
  RandSeed      : Longint = 0;    { Random seed                          }
  SelectorInc   : Word    = 0;    { Selector increment                   }
  Test8086      : Byte    = 0;    { 80x86 test result                    }
  FileMode      : Byte    = 2;    { File open mode                       }
{}{$ENDIF}{}

{ Uninitialized public variables. The compiler depends upon the }
{ order of declaration of the following variables, so it must   }
{ not be changed. In addition, the following declaration        }
{ section must be the first "var" section in this unit.         }

var
  Input    : Text;              { Input standard file  }
  Output   : Text;              { Output standard file }

{}{$IFDEF MSDOS}{}
  SaveInt00: Pointer;           { Saved interrupt $00 }
  SaveInt02: Pointer;           { Saved interrupt $02 }
  SaveInt1B: Pointer;           { Saved interrupt $1B }
  SaveInt21: Pointer;           { Saved interrupt $21 }
  SaveInt23: Pointer;           { Saved interrupt $23 }
  SaveInt24: Pointer;           { Saved interrupt $24 }
  SaveInt34: Pointer;           { Saved interrupt $34 }
  SaveInt35: Pointer;           { Saved interrupt $35 }
  SaveInt36: Pointer;           { Saved interrupt $36 }
  SaveInt37: Pointer;           { Saved interrupt $37 }
  SaveInt38: Pointer;           { Saved interrupt $38 }
  SaveInt39: Pointer;           { Saved interrupt $39 }
  SaveInt3A: Pointer;           { Saved interrupt $3A }
  SaveInt3B: Pointer;           { Saved interrupt $3B }
  SaveInt3C: Pointer;           { Saved interrupt $3C }
  SaveInt3D: Pointer;           { Saved interrupt $3D }
  SaveInt3E: Pointer;           { Saved interrupt $3E }
  SaveInt3F: Pointer;           { Saved interrupt $3F }
  SaveInt75: Pointer;           { Saved interrupt $75 }
{}{$ENDIF}{}

{}{$IFDEF DPMI}{}
  SaveInt00: Pointer;           { Saved exception $00 }
  SaveInt02: Pointer;           { Saved interrupt $02 }
  SaveInt0C: Pointer;           { Saved exception $0C }
  SaveInt0D: Pointer;           { Saved exception $0D }
  SaveInt1B: Pointer;           { Saved interrupt $1B }
  SaveInt21: Pointer;           { Saved interrupt $21 }
  SaveInt23: Pointer;           { Saved real mode interrupt $23 }
  SaveInt24: Pointer;           { Saved real mode interrupt $24 }
  SaveInt34: Pointer;           { Saved interrupt $34 }
  SaveInt35: Pointer;           { Saved interrupt $35 }
  SaveInt36: Pointer;           { Saved interrupt $36 }
  SaveInt37: Pointer;           { Saved interrupt $37 }
  SaveInt38: Pointer;           { Saved interrupt $38 }
  SaveInt39: Pointer;           { Saved interrupt $39 }
  SaveInt3A: Pointer;           { Saved interrupt $3A }
  SaveInt3B: Pointer;           { Saved interrupt $3B }
  SaveInt3C: Pointer;           { Saved interrupt $3C }
  SaveInt3D: Pointer;           { Saved interrupt $3D }
  SaveInt3E: Pointer;           { Saved interrupt $3E }
  SaveInt3F: Pointer;           { Saved interrupt $3F }
  SaveInt75: Pointer;           { Saved interrupt $75 }

  RealModeRegs: array[0..49] of Byte; { Real mode call-back registers }
{}{$ENDIF}{}

implementation

const
  TrueStr : string[4] = 'TRUE';
  FalseStr: string[5] = 'FALSE';

const
  NewLineStr: array [0..1] of char = (^M, ^J);

{}{$IFNDEF WINDOWS}{}
var
  CWDefault  : word;                   { Default control word      }

var
  TempLong   : longint;                { Temporary longword        }
  TempWord   : word absolute TempLong; { Temporary word            }

var
  CtrlWord   : word;                   { Saved control word        }
  StatWord   : word;                   { Saved status word         }
  TagWord    : word;                   { Saved tag word            }
  Instruction: pointer;                { Saved instruction pointer }
  Operand    : pointer;                { Saved operand pointer     }
  EnvBuffer  : array [0..13] of byte absolute CtrlWord; { Environment buffer }

const
  ln2_hi: array [0..7] of byte = ($00, $00, $e0, $fe, $42, $2e, $e6, $3f);
  ln2_lo: array [0..7] of byte = ($76, $3c, $79, $35, $ef, $39, $ea, $3d);
{}{$ELSE}{}
var
  TempLong   : longint;                { Temporary longword        }
  CtrlWord   : word;                   { Saved control word        }
{}{$ENDIF}{}

{ The following external routines implement all Turbo Pascal   }
{ standard procedures, functions, and operators. The compiler  }
{ depends upon the order of declaration of these routines, so  }
{ it must not be changed. In addition, these routines must be  }
{ the first declared by this unit, so no procedures and        }
{ functions can be declared in the interface part. The comment }
{ following each external directive specifies the .ASM module  }
{ that contains the routine.                                   }

procedure InitTurbo;            external { MAIN.ASM / DAPP.ASM / WAPP.ASM };
procedure HaltError;            external { MAIN.ASM / DEND.ASM / WEND.ASM };
procedure HaltTurbo;            external { MAIN.ASM / DEND.ASM / WEND.ASM };
procedure BlockMove;            external { VARH.ASM    };
procedure LongMul;              external { LONGMUL.ASM };
procedure LongDiv;              external { LONGDIV.ASM };
procedure LongShr;              external { LONGSHR.ASM };
procedure LongShl;              external { LONGSHL.ASM };
procedure LongMulOvf;           external { LOVF.ASM    };
procedure Overflow;             external { ERRCOVR.ASM };
procedure SLoad;                external { STRHLOD.ASM };
procedure SStore;               external { STRHSTO.ASM };
procedure RangeError;           external { ERRCRNG.ASM };
procedure SCopy;                external { STRHCPY.ASM };
procedure SConcat;              external { STRHCAT.ASM };
procedure SPos;                 external { STRHPOS.ASM };
procedure SCompare;             external { STRHCMP.ASM };
procedure SChar;                external { STRHCHR.ASM };
procedure SPacked;              external { STRHPCK.ASM };
procedure SInsert;              external { STRHINS.ASM };
procedure SDelete;              external { STRHDEL.ASM };
procedure ZLoad;                external { SETHLOD.ASM };
procedure ZStore;               external { SETHSTO.ASM };
procedure ZBitMask;             external { SETHMSK.ASM };
procedure FTrunc;               external { F87HTRC.ASM };
procedure FRound;               external { F87HRND.ASM };
procedure FInt;                 external { F87HINT.ASM };
procedure FSqrt;                external { F87HSQRT.ASM };
procedure FSin;                 external { F87HSICO.ASM / WE87.ASM };
procedure FCos;                 external { F87HSICO.ASM / WE87.ASM };
procedure FArcTan;              external { F87HATAN.ASM / WE87.ASM };
procedure FLn;                  external { F87HLN.ASM  };
procedure FExp;                 external { F87HEXP.ASM  / WE87.ASM };
procedure NewPtr;               external { HEAPNPT.ASM  / WMEM.ASM };
procedure DisposePtr;           external { HEAPDPT.ASM  / WMEM.ASM };
procedure MarkPtr;              external { HEAPMRK.ASM  / WMEM.ASM };
procedure ReleasePtr;           external { HEAPREL.ASM  / WMEM.ASM };
procedure GetFreMem;            external { HEAPSTA.ASM  / WMEM.ASM };
procedure GetFreMax;            external { HEAPSTA.ASM  / WMEM.ASM };
procedure ZWordLoad;            external { SETHWLD.ASM };
procedure ZAddComp;             external { SETHADC.ASM };
procedure ZAddRange;            external { SETHADR.ASM };
procedure ZUnion;               external { SETHUNIT.ASM };
procedure ZDifference;          external { SETHDIF.ASM };
procedure ZIntersect;           external { SETHITS.ASM };
procedure ZEqual;               external { SETHEQU.ASM };
procedure ZRelation;            external { SETHREL.ASM };
procedure GetParCnt;            external { PARSCNT.ASM / WPARCNT.ASM };
procedure GetIORes;             external { ERRCIOG.ASM };
procedure InOutCheck;           external { ERRCIOC.ASM };
procedure RangeCheck;           external { ERRCRNG.ASM };
procedure StackCheck;           external { ERRCSTK.ASM };
procedure WriteFloat;           external { TF87WR.ASM  };
procedure WriteStr;             external { TSTRWR.ASM  };
procedure WriteInt;             external { TINTWR.ASM  };
procedure WriteBool;            external { TBOL.ASM    };
procedure WriteChar;            external { TCHRWR.ASM  };
procedure WriteLine;            external { TGPCWR.ASM  };
procedure WriteEnd;             external { TGPCEND.ASM };
procedure WriteFile;            external { FCTLR_W.ASM };
procedure ReadFloat;            external { TF87RD.ASM  };
procedure ReadStr;              external { TSTRRD.ASM  };
procedure ReadInt;              external { TINTRD.ASM  };
procedure ReadChar;             external { TCHRRD.ASM  };
procedure ReadLine;             external { TGPCRD.ASM  };
procedure ReadEnd;              external { TGPCEND.ASM };
procedure ReadFile;             external { FCTLR_W.ASM };
procedure InitRand;             external { RANDINI.ASM };
procedure AssignText;           external { TCTLKER.ASM };
procedure ResetText;            external { TCTLKER.ASM };
procedure RewriteText;          external { TCTLKER.ASM };
procedure CloseText;            external { TCTLKER.ASM };
procedure AssignFile;           external { FCTLASS.ASM };
procedure ResetFile;            external { FCTLKER.ASM };
procedure RewriteFile;          external { FCTLKER.ASM };
procedure CloseFile;            external { FCTLKER.ASM };
procedure EraseFile;            external { FDIRDEL.ASM };
procedure RenameFile;           external { FDIRREN.ASM };
procedure GetSEoln;             external { TFUN.ASM    };
procedure GetSEof;              external { TFUN.ASM    };
procedure GetTEoln;             external { TFUN.ASM    };
procedure GetTEof;              external { TFUN.ASM    };
procedure ReadBlock;            external { FCTLBLK.ASM };
procedure WriteBlock;           external { FCTLBLK.ASM };
procedure SeekFile;             external { FCTLSEK.ASM };
procedure GetFPos;              external { FFUNPOS.ASM };
procedure GetFSize;             external { FFUNSIZ.ASM };
procedure GetFEof;              external { FFUNEOF.ASM };
procedure FFrac;                external { F87HFRC.ASM };
procedure UpperCase;            external { CHAR.ASM    };
procedure TruncFile;            external { FCTLTRC.ASM };
procedure FillMem;              external { MEMHFIL.ASM };
procedure RandInt;              external { RANDINT.ASM };
procedure RandFloat;            external { RANDF87.ASM };
procedure GetParStr;            external { PARSSTR.ASM / WPARSTR.ASM };
procedure MoveMem;              external { MEMHMOV.ASM };
procedure StrInt;               external { SINTSTR.ASM };
procedure ValInt;               external { SINTVAL.ASM };
procedure StrFloat;             external { SF87STR.ASM };
procedure ValFloat;             external { SF87VAL.ASM };
procedure DirGet;               external { DIRHGET.ASM };
procedure DirSet;               external { DIRHSET.ASM };
procedure DirCreate;            external { DIRHMAK.ASM };
procedure DirRemove;            external { DIRHREM.ASM };
procedure AppendText;           external { TCTLKER.ASM };
procedure FlushText;            external { TCTLKER.ASM };
procedure BufferText;           external { TCTLHLP.ASM };
procedure FRealExt;             external { F87HR2E.ASM };
procedure FExtReal;             external { F87HE2R.ASM };
procedure RAdd;                 external { FP48KER.ASM };
procedure RSub;                 external { FP48KER.ASM };
procedure RMul;                 external { FP48KER.ASM };
procedure RDiv;                 external { FP48KER.ASM };
procedure RCmp;                 external { FP48KER.ASM };
procedure RFloat;               external { FP48KER.ASM };
procedure RTrunc;               external { FP48KER.ASM };
procedure RRound;               external { FP48KER.ASM };
procedure RSqr;                 external { FP48KER.ASM };
procedure WriteReal;            external { TF48WR.ASM  };
procedure ReadReal;             external { TF48RD.ASM  };
procedure StrReal;              external { SF48STR.ASM };
procedure ValReal;              external { SF48VAL.ASM };
procedure RInt;                 external { F48FINT.ASM };
procedure RFrac;                external { F48FFRC.ASM };
procedure RSqrt;                external { F48FSRT.ASM };
procedure RSin;                 external { F48FSIN.ASM };
procedure RCos;                 external { F48FSIN.ASM };
procedure RLn;                  external { F48FLOG.ASM };
procedure RExp;                 external { F48FEXP.ASM };
procedure RArcTan;              external { F48FATN.ASM };
procedure RandReal;             external { RANDF48.ASM };
procedure InitEM86;             external { EI8X.ASM / WI87.ASM };
procedure InitEM87;             external { EI8X.ASM / WI87.ASM };
procedure Construct;            external { OBJHCON.ASM };
procedure Destruct;             external { OBJHDES.ASM };
procedure CopyObject;           external { OBJHCPY.ASM };
procedure MethodCheck;          external { OBJHCHK.ASM };
procedure FindMethod;           external { DMTH.ASM    };
procedure CallMethod;           external { DMTH.ASM    };
procedure ReadPChar;            external { TPCHRD.ASM  };
procedure WritePChar;           external { TPCHWR.ASM  };
procedure AssignTextC;          external { TCTLKER.ASM };
procedure AssignFileC;          external { FCTLASS.ASM };
procedure RenameFileC;          external { FDIRREN.ASM };
procedure StrIntC;              external { SINTSTR.ASM };
procedure ValIntC;              external { CINTVAL.ASM };
procedure StrFloatC;            external { SF87STR.ASM };
procedure ValFloatC;            external { CF87VAL.ASM };
procedure StrRealC;             external { SF48STR.ASM };
procedure ValRealC;             external { CF48VAL.ASM };

{}{$IFDEF MSDOS}{}
procedure LibEntry;             external { MAIN.ASM };
procedure LibExit;              external { MAIN.ASM };
procedure LibExitProc;          external { MAIN.ASM };
procedure InitTask;             external { MAIN.ASM };
{}{$ELSE}{}
procedure LibEntry;             external { DLIB.ASM / WLIB.ASM };
procedure LibExit;              external { DLIB.ASM / WLIB.ASM };
procedure LibExitProc; export;  external { DLIB.ASM / WLIB.ASM };
procedure InitTask; far;        external 'KERNEL' index $005B;
{}{$ENDIF}{}

{ The following routines are private to the runtime library.    }
{ They are not referenced by the compiler, and the order of     }
{ declaration is not important. More routines may be added here }
{ without affecting the compiler/RTL interface.                 }

{}{$IFDEF DPMI}{}
procedure __AHIncr; far;         external 'KERNEL' index $0072;
procedure __0040H; far;          external 'KERNEL' index $00C1;
procedure __A000H; far;          external 'KERNEL' index $00AE;
procedure __B000H; far;          external 'KERNEL' index $00B5;
procedure __B800H; far;          external 'KERNEL' index $00B6;
procedure MEMallocateBlock; far; external 'RTM'    index $0005;
procedure MEMfreeBlock; far;     external 'RTM'    index $0006;
procedure MEMqueryFreeMem; far;  external 'RTM'    index $0015;
{}{$ENDIF}{}

{}{$IFDEF WINDOWS}{}
procedure LocalInit; far;         external 'KERNEL'   index $0004;
procedure GlobalAlloc; far;       external 'KERNEL'   index $000F;
procedure GlobalFree; far;        external 'KERNEL'   index $0011;
procedure GlobalLock; far;        external 'KERNEL'   index $0012;
procedure GlobalUnlock; far;      external 'KERNEL'   index $0013;
procedure GlobalHandle; far;      external 'KERNEL'   index $0015;
procedure GlobalCompact; far;     external 'KERNEL'   index $0019;
procedure WaitEvent; far;         external 'KERNEL'   index $001E;
procedure GetModuleFileName; far; external 'KERNEL'   index $0031;
procedure __AHIncr; far;          external 'KERNEL'   index $0072;
procedure GetWinFlags; far;       external 'KERNEL'   index $0084;
procedure GetFreeSpace; far;      external 'KERNEL'   index $00A9;
procedure MessageBox; far;        external 'USER'     index $0001;
procedure InitApp; far;           external 'USER'     index $0005;
procedure __FPMath; far;          external 'WIN87EM'  index $0001;
procedure AnsiToOem; far;         external 'KEYBOARD' index $0005;
procedure OemToAnsi; far;         external 'KEYBOARD' index $0006;
{}{$ENDIF}{}
(*
procedure PrintString;   external { MAIN.ASM };
procedure Terminate;     external { MAIN.ASM / DEND.ASM / WEND.ASM };
procedure DoExitProcs;   external { DEND.ASM / WEND.ASM };
procedure ExceptHalt;    external { DAPP.ASM     };
procedure CmpAbsValue;   external { FP48CMP.ASM  };
procedure CmpMantissa;   external { FP48CMP.ASM  };
procedure RealFloat;     external { FP48FLT.ASM  };
procedure ROverflow;     external { FP48KER.ASM  };
procedure RealAdd;       external { FP48KER.ASM  };
procedure RealDiv;       external { FP48KER.ASM  };
procedure RealDivRev;    external { FP48KER.ASM  };
procedure RealMul;       external { FP48KER.ASM  };
procedure RealMulNChk2;  external { FP48KER.ASM  };
procedure RealMulNoChk;  external { FP48KER.ASM  };
procedure RealSqr;       external { FP48KER.ASM  };
procedure RealSqrNoChk;  external { FP48KER.ASM  };
procedure RealSub;       external { FP48KER.ASM  };
procedure RealTrunc;     external { FP48RND.ASM  };
procedure RealFrac;      external { F48FFRC.ASM  };
procedure RealPoly;      external { F48FPOL.ASM  };
procedure RealReduceMP;  external { F48FRED.ASM  };
procedure RealMulF;      external { FASTMUL2.ASM };
procedure RealMulFNChk2; external { FASTMUL2.ASM };
procedure RealMulFNoChk; external { FASTMUL2.ASM };
procedure ShortMul;      external { FASTMUL2.ASM };
procedure ShortMulRev;   external { FASTMUL2.ASM };
procedure Int2Str;       external { DINTI2S.ASM  };
procedure Str2Int;       external { DINTS2I.ASM  };
procedure PartOne;       external { SFHELP.ASM   };
procedure PartTwo;       external { SFHELP.ASM   };
procedure Power10;       external { DF48HLP.ASM  };
procedure Times10;       external { DF48HLP.ASM  };
procedure Real2Str;      external { DF48R2S.ASM  };
procedure Str2Real;      external { DF48S2R.ASM  };
procedure NextRand;      external { RANDKER.ASM  };
procedure DisMemory;     external { HEAPDME.ASM / WMEM.ASM };
procedure NewMemory;     external { HEAPNME.ASM / WMEM.ASM };
procedure Check8087;     external { F87HKER.ASM  };
procedure Init8087;      external { F87HKER.ASM  };
procedure E087_Entry;    external { EM87.ASM     };
procedure E087_Shortcut; external { EM87.ASM     };
procedure Float2Str;     external { DF87F2S.ASM  };
procedure Power10_87;    external { DF87HLP.ASM  };
procedure Str2Float;     external { DF87S2F.ASM  };
procedure FileClose;     external { TCTLKER.ASM  };
procedure FileRead;      external { TCTLKER.ASM  };
procedure FileWrDev;     external { TCTLKER.ASM  };
procedure FileWrite;     external { TCTLKER.ASM  };
procedure WriteBuffer;   external { TGPCBUF.ASM  };
procedure FlushProc;     external { TGPCFLS.ASM  };
procedure InOutProc;     external { TGPCIO.ASM   };
procedure WriteBlanks;   external { TGPCPAD.ASM  };
procedure ReadText;      external { TGPCTXT.ASM  };
procedure OpenFile;      external { FCTLKER.ASM  };
procedure OpenCheck;     external { FCTLASS.ASM  };
procedure DosPath;       external { DIRHHLP.ASM  };
procedure GetPath;       external { DIRHHLP.ASM  };
procedure FileData;      external { FFUNKER.ASM  };
procedure ParStrCnt;     external { PARSKER.ASM / WPARKER.ASM };
procedure FileOpen;      external { TFIO.ASM     };
procedure Exception;     external { WX87.ASM     };
procedure ReadCallBack;  external { TRDCALLB.ASM };
procedure ClearDSeg;     external { LAST.ASM     };
*)
end.